/*
   This file demonstrates that polymorphism can take precedence
   over method calls that would seem to be in scope.
*/

class TopLevelClass
{
   public void methodA()
   {
      System.out.println("This is methodA() in TopLevelClass");
   }

   public void methodB()
   {
      // The following two method calls are polymorphic,
      // so they need not call methodA() in this class.
      methodA();
      this.methodA();
   }
}//TopLevelClass


class LowLevelClass extends TopLevelClass
{
   public void methodA()
   {
      System.out.println("This is methodA() in LowLevelClass");
   }
}//LowLevelClass


public class InternalPolymorphism
{
   public static void main( String[] args )
   {
      TopLevelClass topLevelReference = new LowLevelClass();

      // The following method call is not polymorphic (why?)
      // but it leads to a ploymorphic method call from within
      // methodB() in TopLevelClass.
      topLevelReference.methodB();
   }//main

}//InternalPolymorphism