/*
   This files test how you can access overriden methods and
   fields is a super class of a super class.
*/

public class PolymorphismAndOverriding
{

   public static void main( String args[] )
   {
       ClassC classc = new ClassC();
       classc.method2();

       System.out.println();
       System.out.println("From within the test class:");

       System.out.println( classc.data );
       System.out.println( ((ClassB)classc).data );
       System.out.println( ((ClassA)classc).data );

       System.out.println();

       classc.method1();
       ((ClassB)classc).method1();  // doesn't work
       ((ClassA)classc).method1();  // doesn't work
   }//main

}//PolymorphismAndOverriding

class ClassA
{
   String data = "data in ClassA";

   void method1()
   {
      System.out.println("method1 from ClassA");
   }
}

class ClassB extends ClassA
{
   String data = "data in ClassB";

   void method1()
   {
      System.out.println("method1 from ClassB");
   }
}

class ClassC extends ClassB
{
   String data = "data in ClassC";

   void method1()
   {
      System.out.println("method1 from ClassC");
   }

   void method2()
   {
      System.out.println("From within ClassC:");

      System.out.println( data );
      System.out.println( super.data );
      System.out.println( ((ClassA)this).data );  // this works for fields

      System.out.println();

      method1();
      super.method1();
      ((ClassA) this).method1();  // this doesn't work for methods
                                  // because of polymorphism

      // It is interesting to note that for fields the following two lines
      // are equivalent
      //    System.out.println( super.data );
      //    System.out.println( ((ClassB)this).data );
      // but for methods the following two lines are not equivalent
      //    super.method1();
      //    ((ClassB) this).method1();
   }
}