/*
   The Circle class is a subclass of Shape, so we will say
   that a Circle object "is a" Shape object.
*/

public class Circle extends Shape
{
   private int radius;

   public Circle(int x, int y, int radius)
   {
      super(x, y);
      this.radius = radius;
   }

   public int getRadius(){ return radius; }

   public double computeArea()
   {
      return Math.PI*Math.pow(radius,2);
      //return Math.PI*radius*radius;
   }

   public double computePerimeter()
   {
      return 2*Math.PI*radius;
   }

   public String toString()
   {
      return "Circle: " + super.toString() + ",\n\t radius = " + radius;
   }

}//Circle
