/*
   The Rectangle class is a subclass of Shape, so we will say
   that a Rectangle object "is a" Shape object.
*/

public class Rectangle extends Shape
{
   private int width;
   private int length;

   public Rectangle(int x, int y, int width, int length)
   {
      super(x, y);
      this.width = width;
      this.length = length;
   }

   public int getWidth(){ return width; }

   public int getLength(){ return length; }

   public double computeArea()
   {
      return width*length;
   }

   public double computePerimeter()
   {
      return 2*(width+length);
   }

   public String toString()
   {
      return "Rectangle: " + super.toString() + ",\n\t width = " + width + ", length = " + length;
   }

}//Rectangle
