/*
   The Square class is a subclass of Rectangle which is a subclass of Shape,
   so we will say that a Square object "is a" Rectangle object and it also
   "is a" Shape object.

   This inheritance is really an example of "code reuse", not
   the "separation of public interface from private implementation".
*/

public class Square extends Rectangle
{
   public Square(int x, int y, int dimension)
   {
      super(x, y, dimension, dimension);
   }

   // Notice that this toString() doesn't really do the right thing.
   // I do not know a good way to get toString() to do the right thing here.
   // (A "bad" way would be for this toString() to edit the string returned
   // by super.toString().)
   public String toString()
   {
      return "Square: " + super.toString();
   }

}//Square
