/*
   The Triangle class is a subclass of Shape, so we will say
   that a Triangle object "is a" Shape object.
*/

public class Triangle extends Shape
{
   private int side;

   // This is an equilateral triangle.
   public Triangle(int x, int y, int side)
   {
      super(x, y);
      this.side = side;
   }

   public int getSide(){ return side; }

   public double computeArea()
   {
      return 0.5*side*side*Math.sin(Math.PI/3);
   }

   public double computePerimeter()
   {
      return 3*side;
   }

   public String toString()
   {
      return "Triangle: " + super.toString() + ",\n\t side = " + side;
   }

}//Triangle
